package containers;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import valueObjects.ActualValue;

public class ActualValueContainer {

	private List<ActualValue> actualValues;
	private double minValue;
	private double maxValue;

	// private List<ActualValue> sortedActualValues;

	public ActualValueContainer() {
		actualValues = new ArrayList<ActualValue>();
		// sortedActualValues = new ArrayList<ActualValue>();
	}

	public void addActualValue(ActualValue av) {

		double actualValue = av.getActualValue();

		if (actualValues.size() == 0) {
			minValue = actualValue;
			maxValue = minValue;
		} else {
			if (actualValue > maxValue)
				maxValue = actualValue;
			else if (actualValue < minValue) {
				minValue = actualValue;
			}
		}
		actualValues.add(av);
	}

	public double getMinValue() {
		return minValue;
	}

	public double getMaxValue() {
		return maxValue;
	}

	public double[] getSortedActualValues() {
		double sortedActualValues[] = new double[actualValues.size()];

		for (int i = 0; i < actualValues.size(); i++) {
			ActualValue av = actualValues.get(i);
			sortedActualValues[i] = av.getActualValue();
		}

		boolean swapped = true;
		while (swapped) {
			swapped = false;
			for (int i = 0; i < sortedActualValues.length - 1; i++) {
				double value1 = sortedActualValues[i];
				double value2 = sortedActualValues[i + 1];
				if (value1 > value2) {
					double temp = value1;
					sortedActualValues[i] = value2;
					sortedActualValues[i + 1] = temp;
					swapped = true;
				}
			}
		}
//		for (int i = 0; i <sortedActualValues.length; i++) {
//			System.out.println(sortedActualValues[i]);
//
//		}
		return sortedActualValues;
	}

	public ActualValue getActualValue(int index) {
		return actualValues.get(index);
	}

	public List<ActualValue> getActualValues() {
		return actualValues;
	}

	public Iterator<ActualValue> getActualValuesIterator() {
		return actualValues.iterator();
	}

	public int getSize() {
		return actualValues.size();
	}

}
