package containers;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import particleSwarm.Particle;

public class ParticleContainer {

	private List<Particle> particles = new ArrayList<Particle>();

	public ParticleContainer() {

	}

	public void addParticle(Particle p) {
		particles.add(p);
	}

	public Particle getParticle(int index) {
		return particles.get(index);
	}

	public int getContainerSize() {
		return particles.size();
	}

	public Iterator<Particle> getParticleContainerIterator() {
		return particles.iterator();
	}

	public Particle getGlobalBestPosition() {

		Particle globalBest = null;
		double globalBestValue = Double.MAX_VALUE;

		for (int i = 0; i < particles.size(); i++) {

			Particle p = particles.get(i);
			double tempVal = p.getSquaredError();
			if (tempVal < globalBestValue) {
				globalBest = p;
				globalBestValue = tempVal;
			}
		}
		return globalBest;
	}
}
