package containers;

import java.util.*;

import fuzzySet.FuzzySet;
import fuzzySet.TrapezoidalFuzzyNumber;
import fuzzySet.TrapezoidalFuzzySet;

public class TrapezoidalFuzzySetContainer implements FuzzySetContainer {

	private List<FuzzySet> fuzzySets = new ArrayList<FuzzySet>();

	public TrapezoidalFuzzySetContainer() {

	}

	public Iterator<FuzzySet> getFuzzySetsIterator() {
		return fuzzySets.iterator();
	}

	@Override
	public List<FuzzySet> getFuzzySets() {
		// TODO Auto-generated method stub
		return fuzzySets;
	}

	@Override
	public int getNumberOfSets() {
		// TODO Auto-generated method stub
		return fuzzySets.size();
	}

	public void addFuzzySet(FuzzySet set) {
		fuzzySets.add(set);
	}

	public void clearFuzzySetContainer() {
		fuzzySets.clear();
	}

	public FuzzySet getFuzzySet(int index) {
		return fuzzySets.get(index);
	}

	public boolean isContained(FuzzySet fs) {

		TrapezoidalFuzzyNumber trapezNum = (TrapezoidalFuzzyNumber) fs
				.getFuzzyNumber();

		double lowerBound1 = trapezNum.getLowerBound();
		double leftCore1 = trapezNum.getLeftCoreValue();
		double rightCore1 = trapezNum.getRightCoreValue();
		double upperBound1 = trapezNum.getUpperBound();

		for (int i = 0; i < fuzzySets.size(); i++) {

			TrapezoidalFuzzyNumber temp = (TrapezoidalFuzzyNumber) fuzzySets
					.get(i).getFuzzyNumber();

			double lowerBound2 = temp.getLowerBound();
			double leftCore2 = temp.getLeftCoreValue();
			double rightCore2 = temp.getRightCoreValue();
			double upperBound2 = temp.getUpperBound();

			if ((lowerBound1 == lowerBound2) && (leftCore1 == leftCore2)
					&& (rightCore1 == rightCore2)
					&& (upperBound1 == upperBound2))
				return true;
		}
		return false;
	}

	public String toString() {

		String s = "[";
		for (int i = 0; i < fuzzySets.size(); i++) {
			TrapezoidalFuzzySet set = (TrapezoidalFuzzySet) fuzzySets.get(i);
			TrapezoidalFuzzyNumber number = (TrapezoidalFuzzyNumber) set
					.getFuzzyNumber();
			if (i < fuzzySets.size() - 1)
				s = s + number + ", ";
			else
				s = s + number.toString() + "]";
		}
		return s;
	}
}
