package performanceMeasures;

import java.text.DecimalFormat;
import java.util.Iterator;

import containers.ActualValueContainer;
import containers.ForecastValueContainer;

import valueObjects.ActualValue;
import valueObjects.ForecastValue;

public class ForecastError {

	private ForecastValueContainer forecastValues;
	private ActualValueContainer actualValues;
	private int order;

	DecimalFormat formatter = new DecimalFormat("0.00");

	public ForecastError(ForecastValueContainer forecastValues,
			ActualValueContainer actualValues, int order) {
		this.forecastValues = forecastValues;
		this.actualValues = actualValues;
		this.order = order;
	}

	public int getMSE() {

		double counter = 0;
		double totalSquareDiff = 0;

		// System.out.println("actual values length: " + actualValues.length);
		// System.out.println("forecasted values length "
		// + forecastValues.getForecastValues().size());
		// NumberFormat nf = NumberFormat.getNumberInstance();
		// nf.setGroupingUsed(false);
		// nf.setMaximumFractionDigits(2);
		// nf.setMinimumFractionDigits(2);

		for (int i = 0; i < forecastValues.getSize(); i++) {

			ForecastValue fv = (ForecastValue) forecastValues
					.getForecastValue(i);
			int forecast = (int) (fv.getValue() + 0.5);
			// System.out.println("getValue: " + forecast);
			double actualValue = actualValues.getActualValue(i + order)
					.getActualValue();
			double tempDiff = (forecast - actualValue);
			// System.out.println(tempDiff);
			// int diff = 0;

			// if (tempDiff < 0)
			// diff = (int) (tempDiff - 0.5);
			// else
			// diff = (int) (tempDiff + 0.5);

			double squareDiff = Math.pow(tempDiff, 2);
			totalSquareDiff = totalSquareDiff + squareDiff;
			counter++;
		}
		// String number = nf.format(totalSquareDiff / counter);
		// return number;
		return (int) ((totalSquareDiff / counter) + 0.5);
	}

	public double getMAPE() {

		double totalDifference = 0;
		double counter = 0;

		for (int i = 0; i < forecastValues.getSize(); i++) {

			ForecastValue fv = forecastValues.getForecastValue(i);
			int forecast = (int) (fv.getValue() + 0.5);
			// System.out.println("fv.getValue " + forecast);
			// double actualValue = actualValues[i];
			double actualValue = actualValues.getActualValue(i + order)
					.getActualValue();
			double absDiff = Math.abs(forecast - actualValue) / actualValue;
			// String temp = formatter.format(absDiff);
			// System.out.println(absDiff);

			totalDifference = totalDifference + absDiff;
			counter++;
		}

		return ((totalDifference / counter) * 100);
	}
}
