package fuzzySet;

import java.util.*;

import valueObjects.ForecastValue;


public class FuzzySetsRelationship {

	private List<FuzzySet> lhs = new ArrayList<FuzzySet>();
	private ForecastValue forecastValue;

	public FuzzySetsRelationship() {
			}

	public Iterator<FuzzySet> getLeftHandSidesIterator() {
		return lhs.iterator();
	}

	public List<FuzzySet> getLeftHandSidesContainer() {
		return lhs;
	}

	public ForecastValue getForecastValue() {
		return forecastValue;
	}

	public void setForecastValue(ForecastValue forecastValue) {
		this.forecastValue = forecastValue;
	}

	public int getSize() {
		return lhs.size();
	}

	public void addFuzzySet(FuzzySet set) {
		lhs.add(set);
	}

	public boolean isContained(FuzzySet fs) {

		for (int i = 0; i < lhs.size(); i++) {

			// TriangularFuzzyNumber temp = (TriangularFuzzyNumber) lhs.get(i)
			// .getFuzzyNumber();
			// if (temp.getMiddleValue() == ((TriangularFuzzyNumber) fs
			// .getFuzzyNumber()).getMiddleValue())
			TrapezoidalFuzzyNumber temp = (TrapezoidalFuzzyNumber) lhs.get(i)
					.getFuzzyNumber();
			double lowerBound1 = temp.getLowerBound();
			double leftCore1 = temp.getLeftCoreValue();
			double rightCore1 = temp.getRightCoreValue();
			double upperBound1 = temp.getUpperBound();

			double lowerBound2 = ((TrapezoidalFuzzyNumber) fs).getLowerBound();
			double leftCore2 = ((TrapezoidalFuzzyNumber) fs).getLeftCoreValue();
			double rightCore2 = ((TrapezoidalFuzzyNumber) fs)
					.getRightCoreValue();
			double upperBound2 = ((TrapezoidalFuzzyNumber) fs).getUpperBound();

			if ((lowerBound1 == lowerBound2) && (leftCore1 == leftCore2)
					&& (rightCore1 == rightCore2)
					&& (upperBound1 == upperBound2))
				return true;
		}
		// System.out.println(" RelationGroup - isContained returns false
		// !!!!");
		return false;
	}

	public String toString() {

		String leftHandSides = "";
		String rightHandSides = "";
		if (forecastValue == null)
			rightHandSides = "";
		else
			rightHandSides = forecastValue.toString();

		for (int i = 0; i < lhs.size(); i++) {
			FuzzySet fs = lhs.get(i);
			leftHandSides += fs.toString() + " ";
		}
		return lhs + " --> " + rightHandSides + "\n";
	}
}
