package fuzzySet;

public class TrapezoidalFunction implements MembershipFunction {

	public TrapezoidalFunction() {
	}

	public double getMembershipDegree(FuzzyNumber fn, double x) {

		double bounds[] = ((TrapezoidalFuzzyNumber) fn).getAllBounds();
		double lowerBound = bounds[0];
		double leftCore = bounds[1];
		double rightCore = bounds[2];
		double upperBound = bounds[3];

		if (x >= lowerBound && x < leftCore) {
			return (x - lowerBound) / (leftCore - lowerBound);
		}
		if (x >= leftCore && x <= rightCore)
			return 1d;
		if (x > rightCore && x <= upperBound)
			return (upperBound - x) / (upperBound - rightCore);
		else
			return 0d;
	}
}
