package fuzzySet;

public class TrapezoidalFuzzyNumber implements FuzzyNumber {

	private double lowerBound;
	private double leftCoreValue;
	private double rightCoreValue;
	private double upperBound;

	public TrapezoidalFuzzyNumber(double lowerBound, double leftCoreValue,
			double rightCoreValue, double upperBound) {
		this.lowerBound = lowerBound;
		this.leftCoreValue = leftCoreValue;
		this.rightCoreValue = rightCoreValue;
		this.upperBound = upperBound;
	}

	public double[] getAllBounds() {
		return new double[] { lowerBound, leftCoreValue, rightCoreValue,
				upperBound };
	}

	public double[] getBounds() {
		return new double[] { lowerBound, upperBound };
	}

	public double[] getCoreValues() {
		return new double[] { leftCoreValue, rightCoreValue };
	}

	public double getLowerBound() {
		return lowerBound;
	}

	public void setLowerBound(double lowerBound) {
		this.lowerBound = lowerBound;
	}

	public double getUpperBound() {
		return upperBound;
	}

	public void setUpperBound(double upperBound) {
		this.upperBound = upperBound;
	}

	public double getLeftCoreValue() {
		return leftCoreValue;
	}

	public void setLeftCoreValue(double leftCoreValue) {
		this.leftCoreValue = leftCoreValue;
	}

	public double getRightCoreValue() {
		return rightCoreValue;
	}

	public void setRightCoreValue(double rightCoreValue) {
		this.rightCoreValue = rightCoreValue;
	}

	public String toString() {
		return "(" + lowerBound + ", " + leftCoreValue + ", " + rightCoreValue
				+ ", " + upperBound + ")";
	}
}
