package fuzzySet;

public class TrapezoidalFuzzySet implements FuzzySet {

	// private List<FuzzySetElement> setElements = new
	// ArrayList<FuzzySetElement>();
	private MembershipFunction function = new TrapezoidalFunction();
	private TrapezoidalFuzzyNumber number;
	private String id;

	public TrapezoidalFuzzySet(String id, TrapezoidalFuzzyNumber number) {
		this.id = id;
		this.number = number;
	}

	public double getDegree(double x) {

		return function.getMembershipDegree(number, x);

	}

	public String getSetId() {
		return id;

	}

	public FuzzyNumber getFuzzyNumber() {
		return number;

	}

	public double getCentroid() {

		double leftCore = number.getLeftCoreValue();
		double rightCore = number.getRightCoreValue();
		return (leftCore + rightCore) / 2;
	}

	// public void addElement(FuzzySetElement element) {
	// setElements.add(element);
	// }

	// public Iterator<FuzzySetElement> getElements() {
	// return setElements.iterator();
	//
	// }

	// public FuzzySetElement getElement(int i) {
	// return setElements.get(i);
	//
	// }

	// public FuzzySetElement getSetElement(double value) {
	//
	// for (int i = 0; i < setElements.size(); i++) {
	// FuzzySetElement tempElement = setElements.get(i);
	// double tempValue = tempElement.getValue();
	// if (tempValue == value)
	// return tempElement;
	// }
	// return null;
	// }

	// public boolean isContained(FuzzySetElement element) {
	//
	// FuzzySetElement tempElement = getSetElement(element.getValue());
	// if (tempElement != null)
	// return true;
	// else
	// return false;
	// }

	public String toString() {

		if (id.length() == 1)
			return " " + id + " = " + number.toString();
		else
			return id + " = " + number.toString();

	}

}
